#ifndef _BLOG_H_
#define _BLOG_H_

#include <glib.h>
#include <glib-object.h>

typedef struct _Blog Blog;
typedef struct _BlogCategory BlogCategory;
typedef struct _BlogPost BlogPost;
typedef struct _BlogParameter BlogParameter;

#include "blog-plugin.h"

struct _Blog {
	gchar *url;
	gchar *user;
	gchar *pass;
	gchar *id;
	gchar *name;
	BlogPlugin *plugin;
	GSList *categories;
	GSList *posts;
	gint refcount;
};

struct _BlogCategory {
	gchar *name;
	gchar *id;
};

struct _BlogPost {
	gchar *id;
	gchar *title;
	GSList *categories;
	GSList *extra_fields;
	gchar *content;
};

struct _BlogParameter {
	gchar *name;
	GValue value;
};

void blog_parameter_free(BlogParameter *param);
void blog_post_free(BlogPost *post);
void blog_category_free(BlogCategory *category);
Blog *blog_new(void);
void blog_ref(Blog *blog);
void blog_unref(Blog *blog);

#endif /* _BLOG_H_ */
